/* openssl/pki_pkey.c */

#include <libpki/pki.h>

/* ---------------- OpenSSL HSM Keypair get/put --------------------------- */

PKI_STACK * HSM_OPENSSL_OBJSK_get_url ( PKI_DATATYPE type, URL *url, 
						PKI_CRED *cred, void *hsm ) {
/*
	void * ret = NULL;

	if( !url ) return ( NULL );

	switch ( type ) {
		case PKI_DATATYPE_KEYPAIR:
			ret = (void *) HSM_OPENSSL_X509_KEYPAIR_get_url ( url,
						cred, hsm );
			break;
		default:
			ret = NULL;
	}

	return ( ret );
*/
	PKI_log_debug("HSM_OPENSSL_OBJSK_get_url()::Deprecated");
	return NULL;
}

PKI_X509_KEYPAIR_STACK * HSM_OPENSSL_X509_KEYPAIR_get_url ( URL *url, 
						PKI_CRED *cred, HSM *hsm) {
/*
	PKI_MEM_STACK *data = NULL;
	PKI_X509_KEYPAIR_STACK *ret = NULL;
	PKI_MEM *obj = NULL;

	PKI_X509_KEYPAIR *pk = NULL;


	if (!url ) return ( NULL );

	if(( data = URL_get_data_url( url, 0 )) == NULL ) {
		PKI_log_debug("ERROR, can not get key data from URL");
		return(NULL);
	}

	if((ret = PKI_STACK_KEYPAIR_new()) == NULL ) {
		PKI_log_debug("ERROR, can not allocate new memory!");
		if( data ) PKI_STACK_MEM_free ( data );
		return ( NULL );
	}

	while ((obj = PKI_STACK_MEM_pop( data )) != NULL ) {

		if(( pk = PKI_X509_KEYPAIR_get_mem ( obj, cred )) == NULL ) {
			if( obj ) PKI_MEM_free (obj);
			continue;
		}
		PKI_STACK_KEYPAIR_push( ret, pk );

		if( obj ) PKI_MEM_free (obj);
	}

	if( data ) PKI_STACK_MEM_free ( data );

        return ( ret );
*/
	PKI_log_debug("HSM_OPENSSL_X509_KEYPAIR_get_url()::Deprecated");
	return NULL;
}


/* Key Pair removal function */
/*
int HSM_OPENSSL_X509_KEYPAIR_remove ( PKI_X509_KEYPAIR *key, char *label, void *driver ) {

	PKI_log_debug( "HSM_OPENSSL_X509_KEYPAIR_get() not implemented!\n");
	return (PKI_ERR);
}
*/

/*
PKI_X509_KEYPAIR_STACK *HSM_OPENSSL_X509_KEYPAIR_get_url( URL *url,
					PKI_CRED *cred, void *driver ) {

	PKI_MEM_STACK *data = NULL;
	PKI_X509_KEYPAIR_STACK *ret = NULL;
	PKI_MEM *obj = NULL;
	BIO *bio = NULL;
	char *pp = NULL;

	if(!url) return NULL;

	if( cred && cred->password ) pp = (char *) cred->password;

	if( url->proto == URI_PROTO_ID ) {
		PKI_log_debug("ERROR, ID type of URI used in software HSM!");
		return ( NULL );
	}

	if(( data = URL_get_data_url( url, 0 )) == NULL ) {
		PKI_log_debug("ERROR, can not get key data from URL");
		return(NULL);
	}

	if((ret = PKI_STACK_KEYPAIR_new((void *)PKI_X509_KEYPAIR_free)) == NULL ) {
		PKI_log_debug("ERROR, can not allocate new memory!");
		if( data ) PKI_STACK_MEM_free ( data );
		return ( NULL );
	}

	while ((obj = PKI_STACK_MEM_pop( data )) != NULL ) {

		PKI_X509_KEYPAIR *pk = NULL;

		if(( bio = BIO_new_mem_buf( obj->data, obj->size )) == NULL ) {
			if( ret ) PKI_STACK_KEYPAIR_free ( ret );
			PKI_log_debug("ERROR, Memory Allocation (%s:%d)",
							__FILE__, __LINE__ );
			break;
		}

		if((pk = (PKI_X509_KEYPAIR *) PEM_read_bio_PrivateKey(bio, NULL, 
						NULL, pp )) == NULL) {
			PKI_log_debug("INFO, Can not load Key (PEM format)" );

			ERR_print_errors_fp(stderr);
			ERR_clear_error();

			if(BIO_reset(bio) == 1 ) {
				pk = (PKI_X509_KEYPAIR *) d2i_PrivateKey_bio(bio, NULL);
				if(!pk ) {
					PKI_log_debug("ERROR, Can not load Key (not "
						"PEM nor DER format)" );
					if( obj ) PKI_MEM_free ( obj );
					break;
				}
			}
		}

		if( obj ) PKI_MEM_free (obj);
		PKI_STACK_KEYPAIR_push( ret, pk );
	}

	if( data ) PKI_STACK_MEM_free ( data );

        return ret;
}

int HSM_OPENSSL_X509_KEYPAIR_export_url( PKI_X509_KEYPAIR *key, char *label, 
			int format, URL *url, PKI_CRED *cred, void *driver ) {

	if( !url ) return ( PKI_ERR );

	switch ( url->proto ) {
		case URI_PROTO_FILE:
			return PKI_OPENSSL_X509_KEYPAIR_export_file( key, format,
					url, cred );
			break;
		default:
			return ( PKI_ERR );
	}
}

int PKI_OPENSSL_X509_KEYPAIR_export_file( PKI_X509_KEYPAIR *key, int format, URL *url,
						PKI_CRED *cred ) {

	BIO *out = NULL;
	int ret = 1;

	if( !key || !url ) return 0;

	switch( format ) {
		case PKI_FORMAT_PEM:
		case PKI_FORMAT_ASN1:
			break;
		default:
			PKI_log_debug( "%s:%d format not recognized (%d)\n",
					__FILE__, __LINE__, format );
			return(PKI_ERR);
	}

	if((out = BIO_new(BIO_s_file())) == NULL ) {
		PKI_log_debug("%s:%d error\n", __FILE__, __LINE__ );
		return (PKI_ERR);
	}

	if( strncmp_nocase( url->addr, "-", 1) == 0 ) {
		 BIO_set_fp(out,stdout,BIO_NOCLOSE);
	} else {
		ret = (int ) BIO_write_filename( out, url->addr);
	}

	switch( format ) {
		case PKI_FORMAT_PEM:
			ret = PEM_write_bio_PrivateKey( out, (EVP_PKEY *) key,
					NULL, NULL, 0, NULL, NULL );
			break;
		case PKI_FORMAT_ASN1:
			ret = i2d_PrivateKey_bio( out, (EVP_PKEY *) key);
			break;
		default:
			PKI_log_debug("%s:%d error\n", __FILE__, __LINE__ );
	}

	if( out ) BIO_free_all (out);

	return(ret);
}

PKI_X509_KEYPAIR * HSM_OPENSSL_X509_KEYPAIR_get_url ( URL *url, PKI_CRED *cred,
							void * driver ) {

	printf("%s:%d::DEBUG::Not Implemented!\n", __FILE__, __LINE__ );

	return ( NULL );
}

*/

